USE [TRGPRODsfDocSys]
GO
/****** Object:  StoredProcedure [dbo].[czqa_RFIList]    Script Date: 09/08/2016 12:53:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER procedure [dbo].[czqa_TRGRFIList]
		@pDocMasterKey	UniqueIdentifier
	,	@pProject		VARCHAR(32)
	,	@pWithinDays	INT=-30
as

-- intended for consumption by word template "qAlias" qRFI
-- returns RFI on the same project that have DOCDATE within days (prior) to reference document's doc date

SET NOCOUNT ON
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED 
DECLARE	@RFIDTK		UniqueIdentifier
	,	@Since		DateTime
	 
DECLARE @Result TABLE (	RFINUM			VARCHAR(16)
					,	Title			VARCHAR(99)
					,	Opened			DATETIME
					,	Closed			DATETIME NULL
				)

SET @RFIDTK = '3BEB0324-64F7-4084-9D83-0399173EEAA6'

SET @Since = (select DATEADD(day,@pWithinDays,dh.docdate) FROM dbo.xsfDocHeader dh WHERE dh.DocMasterKey = @pDocMasterKey)
SET @Since = DATEADD(dd, 0, DATEDIFF(dd, 0, @Since))

INSERT INTO @Result 
SELECT  dh.docno
	,	dh.Title
	,	dh.DocDate
	,	dh.Closed
FROM dbo.xsfDocHeader dh 
WHERE dh.project = @pProject 
and dh.DocTypeKey = @RFIDTK
and ( dh.docdate >=  @Since)
	   

SELECT	 r.*
FROM @Result r
ORDER BY 1
-- result order??? -- ORDER BY ???

-- drop procedure czqa_TRGRFIList
-- exec czqa_TRGRFIList '33cdb0ee-bddd-42f0-8e61-fd93cc4638b7','GC003'			 
BEGIN TRANSACTION 
DELETE FROM dbo.xsfRuleItem WHERE TestValue LIKE 'qRFI:Alias%'; 
INSERT INTO dbo.xsfRuleItem VALUES ('27403D7D-8C13-4C5A-B559-20AA8332F39D','DD9E2F02-D08B-462F-B12C-7B3D0DABD43D',0,0,'qRFI:Alias',null,'exec czqa_TRGRFIList @pDocMasterKey,@pProject',default); 
COMMIT  
