USE [TRGPRODsfDocSys]
GO
/****** Object:  StoredProcedure [dbo].[czqa_SubmittalItems]    Script Date: 09/08/2016 12:52:27 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER procedure [dbo].[czqa_SubmittalItems]
		@pDocMasterKey	UniqueIdentifier
	,	@pProject		VARCHAR(32)
	,	@pWithinDays	INT=30
as

-- intended for consumption by word template "qAlias" qSI
-- returns submittal items on the same project that have DUE DATE within days of the reference document's doc date

SET NOCOUNT ON
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED 
DECLARE	@SubRegDTK		UniqueIdentifier
	,	@DueBefore		DateTime
	 
DECLARE @Result TABLE (	SINUM			VARCHAR(16)
					,	Description		VARCHAR(999)
					,	ItemDate		DATETIME
					,	ItemClosed		DATETIME NULL
				)

SET @SubRegDTK = 'E892DDAE-C38F-4CA7-B520-05479A70B2EE'

SET @DueBefore = (select DATEADD(day,@pWithinDays,dh.docdate) FROM dbo.xsfDocHeader dh WHERE dh.DocMasterKey = @pDocMasterKey)
SET @DueBefore = DATEADD(MINUTE, (23 * 60) + 59 ,DATEADD(dd, 0, DATEDIFF(dd, 0, @DueBefore))) 


SET NOCOUNT ON;
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
SET Deadlock_Priority LOW;
SET ANSI_WARNINGS OFF

DECLARE  
	@NullUserKey		UniqueIdentifier,
	@UCF_AllItems 		VARCHAR(40),
	@UCF_CompanyItems	VARCHAR(40),
	@TaskMask			VARCHAR(44),
	@DevMode			INT,
	@RowCount			INT


SET @SubRegDTK		= 'E892DDAE-C38F-4CA7-B520-05479A70B2EE'
--SET @SubmittalDTK	= '080E17ED-1E16-47BE-8639-4CD62EB8318E' 
--SET @PackageDTK 	= '05AC1337-57F5-4020-BE53-900B9BCC8F82'
SET @NullUserKey 	= '00000000-0000-0000-0000-000000000000'
SET @UCF_AllItems 	= 'D8E29CB5-6C04-4086-ACC7-72AD9813764A' 		-- DOC      AllItems                   9          Allow            Special          Permissions for any item on the document
SET @UCF_CompanyItems 	= '8DDC1F00-3155-4204-8666-9D75F5F748ED' 	-- DOC      ViewCompanyItems           1          Allow            Special          Can see all items that have the same company
SET	@DevMode		= 0

SET @TaskMask		= dbo.f_SOLProjectFlexkey( 'TASK' ) 

DECLARE @ItemRegister TABLE(
								DocItemKey	UniqueIdentifier Primary Key,
								Project		VARCHAR(32),
								RegisterDoc	UniqueIdentifier 
		--SubmittalDoc	UniqueIdentifier,
		--PackageDoc	UniqueIdentifier
							)	
	
DECLARE @ItemStatusState TABLE( Code VARCHAR(8), IsApproved BIT, IsClosed BIT, IsHistory BIT)
DECLARE @ItemStateList TABLE (ItemStateCode VARCHAR(3))
 
INSERT INTO @ItemStatusState (Code, IsApproved , IsClosed, IsHistory )
		SELECT CASE WHEN TestValue LIKE 'sf%' THEN SUBSTRING(TestValue,3,2) ELSE TestValue END
				,	[dbo].[f_RuleResultBit]('DocItemStatusIsApproved', @SubRegDTK, TestValue )
				,	1
				,	dbo.f_RuleResultBit('DocItemConfig',@SubRegDTK,'AutoCopyWhen:'+TestValue )
			FROM dbo.xsfRuleItem ri
				WHERE RuleKey = '820B3EBA-5EB1-4E1A-99CB-408F99AB139A' -- ItemStatusClosed
				  AND ISNULL(FilterValue,cast(@SubRegDTK as varchar(44))) = cast(@SubRegDTK as varchar(44))
					AND ResultValue = '1'		
					and ( ( testvalue not like 'sf%' and IsDistributed = 0)
							or not exists (select * from dbo.xsfRuleItem sri
											WHERE sri.TestValue = ri.TestValue  
												and sri.RuleKey = ri.RuleKey 
												and sri.ResultValue = '0'
												and sri.IsDistributed = 0 
												and ISNULL(sri.FilterValue,'x') = ISNULL(ri.FilterValue,'x')
												)
							)

INSERT INTO @ItemRegister( DocItemKey, Project, RegisterDoc )
	SELECT dl.DocItemKey, dh.Project, dh.DocMasterKey as registerDoc
	  FROM dbo.xsfDocHeader  dh
		JOIN dbo.vsf_RevisionInfo di ON di.DocMasterKey = dh.DocMasterKey
		JOIN dbo.xsfDocRevItem dvi ON dvi.DocRevKey = di.DocRevKey
		JOIN dbo.xsfDocItem  dl on dl.DocItemKey = dvi.DocItemKey
	 WHERE dh.DocTypeKey = @SubRegDTK
	AND(dh.project LIKE @pProject)	

SET @RowCount = @@ROWCOUNT
IF @DevMode > 0 PRINT CONVERT(VARCHAR(33),getdate(),121) + ': Item Register Size - '  + STR(@ROWCOUNT) ;
  
 

WITH SIData AS (
					SELECT 	
						dl.DocItemKey,
						dbo.f_StripHTML(dl.[Description],0)										as ItemDescription,
						dvi.ItemNumber,
						dl.SourceItemNumber,
						dl.ItemType,
						dl.ItemSubtype,
						dl.ItemSource,
						dl.ItemStatus,
						dlt.ProjEntity,
						dbo.f_DescribeCode( 'ItemType' ,  dl.ItemType, dh.docTypeKey)			as ItemTypeDescription,
						dbo.f_DescribeCode( 'ItemSubtype' ,  dl.ItemSubtype, dh.docTypeKey)		as ItemSubtypeDescription,
						dbo.f_DescribeCode( 'ItemSource' ,  dl.ItemSource, dh.docTypeKey)		as ItemSourceDescription,
						dbo.f_DescribeCode( 'ItemStatus' ,  dl.ItemStatus, dh.docTypeKey)		as ItemStatusDescription,
						[dbo].[f_MaskString](dlt.ProjEntity, @TaskMask) 						as ProjEntityMasked, 
						dl.ResponsibleParty,
						siRP.UserName  															as ResponsiblePartyName,
						siRP.Company 															as ResponsibleCompany,
						dlt.Note,
						dl.DrawingNumber,
						ISNULL(dl.RevisionNumber,'')											as RevisionNumber,
						ISNULL(dl.Paragraph,'')													as Paragraph,
						ISNULL(dl.Specification,'')												as Specification,

						-- Status dates
						ISNULL(dl.Due,GETDATE())				as SubmittalDue,
						 dl.Requested							as Requested,
						dl.Received								as Received,
						dl.Submitted							as Submitted,
						dl.Reviewed								as Reviewed, 
						CASE	WHEN iss.IsApproved = 1 THEN 'A' -- approved
								WHEN iss.IsHistory = 1  THEN 'R' -- history
								WHEN iss.IsClosed  = 1  THEN 'C' -- canceled
								WHEN dl.Requested is null THEN '0'
								WHEN ISNULL(dl.Received, DATEADD(d,-1,dl.requested)) < dl.Requested THEN '1' 
								WHEN ISNULL(dl.Submitted, DATEADD(d,-1,dl.Received )) < dl.Received  THEN '2' 
								WHEN ISNULL(dl.Reviewed , DATEADD(d,-1,dl.Submitted )) < dl.Submitted  THEN '4' 
								ELSE '8'
								END								as ItemState

						 
						
				 
					 

					  FROM @ItemRegister IR 
						JOIN dbo.xsfDocHeader dh ON dh.DocMasterKey = IR.RegisterDoc
						JOIN dbo.vsf_RevisionInfo di ON di.DocMasterKey = IR.RegisterDoc
						-- JOIN dbo.xsfDocRevision dv ON dv.DocRevKey = di.DocRevKey
						JOIN dbo.xsfDocRevItem dvi ON dvi.DocRevKey = di.DocRevKey
						JOIN dbo.xsfDocItem dl on dl.DocItemKey = dvi.DocItemKey and dl.DocItemKey = ir.DocItemKey 
						LEFT OUTER JOIN dbo.xsfDocItemTask dlt ON dlt.DocItemKey  = dl.DocItemKey
						LEFT OUTER JOIN @ItemStatusState iss on iss.Code = dl.ItemStatus 
						LEFT OUTER JOIN dbo.xsfUser siRP ON siRP.UserKey = dl.ResponsibleParty

						-- LEFT OUTER JOIN dbo.vsf_ProjectReportDetails ph on PH.project = dh.project  
					  WHERE 
						(dh.project LIKE @pProject)
						and ISNULL(dl.Due,GETDATE())	 <= @DueBefore
			)
	SELECT 
			-- SIData.DocItemKey,
			SIData.ItemDescription,
			SIData.ItemNumber,
			SIData.SourceItemNumber,
			SIData.ItemType,
			SIData.ItemSubtype,
			SIData.ItemSource,
			SIData.ItemStatus,
			SIData.ProjEntity,
			SIData.ItemTypeDescription,
			SIData.ItemSubtypeDescription,
			SIData.ItemSourceDescription,
			SIData.ItemStatusDescription,
			SIData.ProjEntityMasked, 
			SIData.ResponsibleParty,
			SIData.ResponsiblePartyName,
			SIData.ResponsibleCompany,
			SIData.Note,
			SIData.DrawingNumber,
			SIData.RevisionNumber,
			SIData.Paragraph,
			SIData.Specification,

			-- Status dates
			SIData.SubmittalDue,
			SIData.Requested,
			SIData.Received,
			SIData.Submitted,
			SIData.Reviewed, 
			SIData.ItemState 

		 
		FROM SIData 
	   
 

-- drop procedure czqa_SubmittalItems
-- exec czqa_SubmittalItems '33cdb0ee-bddd-42f0-8e61-fd93cc4638b7','GC003'			 
BEGIN TRANSACTION 
DELETE FROM dbo.xsfRuleItem WHERE TestValue LIKE 'qSI:Alias%'; 
INSERT INTO dbo.xsfRuleItem VALUES ('0D641596-C066-4CAB-8AF6-9C04487B5AFF','DD9E2F02-D08B-462F-B12C-7B3D0DABD43D',0,0,'qSI:Alias',null,'exec czqa_SubmittalItems @pDocMasterKey,@pProject',default); 
COMMIT  
